#include <iostream>
#include <fstream>

using namespace std;

const int MAXN = 2e6;

int fr[MAXN], nr_mult[MAXN];

int main() 
{
    ifstream fin("cmmdc.in");
    ofstream fout("cmmdc.out");

    int n, val, k, vmax = 0;

    fin >> n >> k;
    for (int i = 1; i <= n; ++i) 
    {
        fin >> val;
        fr[val]++;
        vmax = max(vmax, val);
    }
	
    for (int d = 1; d <= vmax; ++d)
        for (int j = d; j <= vmax; j += d) // pt fieacre multiplu j al lui d
            nr_mult[d] += fr[j];
     
     // d = 2
     // 4 2 6 5 4 6
     // nr_mult[2] += 1
     // nr_mult[2] += 2
     // nr_mult[2] += 2
     // nr_mult[2] = 5;

    for (int d = vmax; d; --d)   // Pt fiecare posibil divizor comun d
        if (nr_mult[d] >= k)     // daca este div comun a cel putin k numere din sir
        {
            fout << d << '\n';   // il scriem - d este cel mai mare divizor comun
			
            for (int md = (vmax / d) * d; md; md -= d)  // md - multiplu al lui d; pornim de la cel mai mare multiplu al lui d, si coboram         
                while (fr[md] > 0)                      // daca md exista in sir
                {
                    fout << md << " ";                   
                    --fr[md];
                    --k;
                    
                    if (k == 0)
						return 0;
                    
                }
        }

    return 0;
}
